#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following package:
library(dplyr) #package version 1.0.10

#2.2. Cognitive Tools

##2.2.1. SHARE Cognitive instrument (SHARE-Cog)

studysample2 <- studysample2 %>%
  mutate(
    wreg10_w8 = case_when(
      cf008tot_w8 == -1 ~ 0,
      cf008tot_w8 >= 0 ~ cf008tot_w8),
    fluency_w8 = case_when(
      cf010_w8 == -1 ~ 0,
      cf010_w8 >= 0 ~ cf010_w8*1),
    recall10_w8 = case_when(
      cf016tot_w8 == -1 ~ 0,
      cf016tot_w8 >= 0 ~ cf016tot_w8),
    sharecog_w8 = round(wreg10_w8*1 + pmin(fluency_w8,30)*0.5 + recall10_w8*2, 0)
  ) #SHARE-Cog weighting chosen based on the weighting sensitivity analysis (see script 3.2.3. Table_S4)

##2.2.2. Cognitive Battery

studysample2 <- studysample2 %>%
  mutate(
    date_w8 = case_when(
      cf003_w8 == -1 | cf003_w8 == 2 ~ 0,
      cf003_w8 == 1 ~ 1),
    month_w8 = case_when(
      cf004_w8 == -1 | cf004_w8 == 2 ~ 0,
      cf004_w8 == 1 ~ 1),
    year_w8 = case_when(
      cf005_w8 == -1 | cf005_w8 == 2 ~ 0,
      cf005_w8 == 1 ~ 1),
    day_w8 = case_when(
      cf006_w8 == -1 | cf006_w8 == 2 ~ 0,
      cf006_w8 == 1 ~ 1),
    orientation = case_when(
      date_w8 >= 0 & month_w8 >= 0 & year_w8 >= 0 & day_w8 >= 0 ~ date_w8 + month_w8 + year_w8 + day_w8),
    serial7s3_w8 = case_when(
      numeracy2_w8 == -1 | numeracy2_w8 == 0 ~ 0, 
      numeracy2_w8 == 1 ~ 1,
      numeracy2_w8 == 2 | numeracy2_w8 == 3 ~ 2,
      numeracy2_w8 == 4 | numeracy2_w8 == 5 ~ 3),
    counting_w8 = case_when(
      cf823_w8 == -1 | cf823_w8 == 5 ~ 0,
      cf826_w8 == -1 | cf826_w8 == 5 ~ 0,
      cf823_w8 == 1 | cf826_w8 == 1 ~ 1),
    objectscissors_w8 = case_when(
      cf827_w8 == -1 | cf827_w8 == 5 ~ 0,
      cf827_w8 == 1 ~ 1),
    objectcactus_w8 = case_when(
      cf828_w8 == -1 | cf828_w8 == 5 ~ 0,
      cf828_w8 == 1 ~ 1),
    objectpharmacy_w8 = case_when(
      cf829_w8 == -1 | cf829_w8 == 5 ~ 0,
      cf829_w8 == 1 ~ 1),
    objects3_w8 = objectscissors_w8 + objectcactus_w8 + objectpharmacy_w8,
    infinity_w8 = case_when(
      cf830_w8 == -1 | cf830_w8 == 2 | cf830_w8 == 5 ~ 0,
      cf830_w8 == 1 ~ 1),
    cube_w8 = case_when(
      cf831_w8 == -1 | cf831_w8 == 2 | cf831_w8 == 5 ~ 0,
      cf831_w8 == 1 ~ 1),
    clockcontour_w8 = case_when( 
      cf833_w8 == -1 ~ 0,
      cf833_w8 == 1 ~ 1,
      cf833_w8 == 5 & cf834_w8 == 5 & cf835_w8 == 1 ~ 1,
      cf833_w8 == 5 & cf834_w8 == 5 & cf835_w8 == 5 ~ 0,
      cf833_w8 == 5 & cf834_w8 == 1 ~ 0,
      cf833_w8 == 5 & (cf834_w8 == -2 | cf834_w8 == -1) ~ 0),
    clocknumbers_w8 = case_when(
      cf833_w8 == -1 ~ 0, 
      cf833_w8 == 1 ~ 1,
      cf833_w8 == 5 & cf834_w8 == 1 ~ 1,
      cf833_w8 == 5 & cf834_w8 == 5 ~ 0,
      cf833_w8 == 5 & (cf834_w8 == -2 | cf834_w8 == -1) ~ 0),
    clockhands_w8 = case_when(
      cf833_w8 == -1 | (cf833_w8 == 5 & cf834_w8 == 5 & cf835_w8 == 5)~ 0,
      (cf833_w8 == 1 | cf833_w8 == 5) & (cf837_w8 == -2 | cf837_w8 == -1 | cf837_w8 == 5) ~ 0,
      cf837_w8 == 1 ~ 1,
      cf833_w8 == 5 ~ 0),
    clock_w8 = clockcontour_w8 + clocknumbers_w8 + clockhands_w8,
    visexec_w8 = clock_w8 + cube_w8 + infinity_w8,
    attentnum_w8 = serial7s3_w8 + counting_w8,
    cogbattery_w8 = visexec_w8 + objects3_w8 + attentnum_w8 + orientation
    )
