#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]

#3.1. Sample Description (Table 1)

##Custom function for calculating percentages
percent <- function(x, y) {paste0(round(sum(x == y)/length(x),n)*100, "%")}
n <- 2 #rounding of decimal places used in percentage calculation

##Custom function for calculating p-values
p_chisq <- function(x, y) {
  chisq <- chisq.test(x, y, correct=FALSE)
  return(
    if(chisq[["p.value"]]<0.001){"<0.001"} else{
      round(chisq[["p.value"]], 3)} )}

##Datasets for each cognitive subgroup
cog1 <- sample_primary[sample_primary$cognitivegroups_w8 == 1, ]
cog2 <- sample_primary[sample_primary$cognitivegroups_w8 == 2, ]
cog3 <- sample_primary[sample_primary$cognitivegroups_w8 == 3, ]
cog4 <- sample_primary[sample_primary$cognitivegroups_w8 == 4, ]

##Table 1
nrow(sample_primary); nrow(cog1); nrow(cog2); nrow(cog3); nrow(cog4) #Number in each cognitive subgroup
Table_1 <- as.data.frame(t(
  data.frame(age_65 = c(percent(sample_primary$agecat_w8, 1), percent(cog1$agecat_w8, 1), percent(cog2$agecat_w8, 1), percent(cog3$agecat_w8, 1), percent(cog4$agecat_w8, 1), p_chisq(sample_primary$agecat_w8, sample_primary$cognitivegroups_w8)), 
             age_75 = c(percent(sample_primary$agecat_w8, 2), percent(cog1$agecat_w8, 2), percent(cog2$agecat_w8, 2), percent(cog3$agecat_w8, 2), percent(cog4$agecat_w8, 2), NA),
             age_85 = c(percent(sample_primary$agecat_w8, 3), percent(cog1$agecat_w8, 3), percent(cog2$agecat_w8, 3), percent(cog3$agecat_w8, 3), percent(cog4$agecat_w8, 3), NA),
             female = c(percent(sample_primary$female, 1), percent(cog1$female, 1), percent(cog2$female, 1), percent(cog3$female, 1), percent(cog4$female, 1), p_chisq(sample_primary$female, sample_primary$cognitivegroups_w8)), 
             education_low = c(percent(sample_primary$educationcat_w8, 1), percent(cog1$educationcat_w8, 1), percent(cog2$educationcat_w8, 1), percent(cog3$educationcat_w8, 1), percent(cog4$educationcat_w8, 1), p_chisq(sample_primary$educationcat_w8, sample_primary$cognitivegroups_w8)), 
             education_medium = c(percent(sample_primary$educationcat_w8, 2), percent(cog1$educationcat_w8, 2), percent(cog2$educationcat_w8, 2), percent(cog3$educationcat_w8, 2), percent(cog4$educationcat_w8, 2), NA),
             education_high = c(percent(sample_primary$educationcat_w8, 3), percent(cog1$educationcat_w8, 3), percent(cog2$educationcat_w8, 3), percent(cog3$educationcat_w8, 3), percent(cog4$educationcat_w8, 3), NA),
             gali_notlimited = c(percent(sample_primary$galimod_w8, 0), percent(cog1$galimod_w8, 0), percent(cog2$galimod_w8, 0), percent(cog3$galimod_w8, 0), percent(cog4$galimod_w8, 0), p_chisq(sample_primary$galimod_w8, sample_primary$cognitivegroups_w8)), 
             gali_limited = c(percent(sample_primary$galimod_w8, 1), percent(cog1$galimod_w8, 1), percent(cog2$galimod_w8, 1), percent(cog3$galimod_w8, 1), percent(cog4$galimod_w8, 1), NA), 
             gali_severelylimited = c(percent(sample_primary$galimod_w8, 3), percent(cog1$galimod_w8, 3), percent(cog2$galimod_w8, 3), percent(cog3$galimod_w8, 3), percent(cog4$galimod_w8, 3), NA), 
             alone = c(percent(sample_primary$livesalone_w8, 1), percent(cog1$livesalone_w8, 1), percent(cog2$livesalone_w8, 1), percent(cog3$livesalone_w8, 1), percent(cog4$livesalone_w8, 1), p_chisq(sample_primary$livesalone_w8, sample_primary$cognitivegroups_w8)), 
             employed = c(percent(sample_primary$ep005mod_w8, 1), percent(cog1$ep005mod_w8, 1), percent(cog2$ep005mod_w8, 1), percent(cog3$ep005mod_w8, 1), percent(cog4$ep005mod_w8, 1), p_chisq(sample_primary$ep005mod_w8, sample_primary$cognitivegroups_w8)), 
             multimorbidity = c(percent(sample_primary$multimorbidity_w8, 1), percent(cog1$multimorbidity_w8, 1), percent(cog2$multimorbidity_w8, 1), percent(cog3$multimorbidity_w8, 1), percent(cog4$multimorbidity_w8, 1), p_chisq(sample_primary$multimorbidity_w8, sample_primary$cognitivegroups_w8)), 
             eyesight_low = c(percent(sample_primary$eyesight_w8, 1), percent(cog1$eyesight_w8, 1), percent(cog2$eyesight_w8, 1), percent(cog3$eyesight_w8, 1), percent(cog4$eyesight_w8, 1), p_chisq(sample_primary$eyesight_w8, sample_primary$cognitivegroups_w8)), 
             hearing_low = c(percent(sample_primary$hearing_w8, 1), percent(cog1$hearing_w8, 1), percent(cog2$hearing_w8, 1), percent(cog3$hearing_w8, 1), percent(cog4$hearing_w8, 1), p_chisq(sample_primary$hearing_w8, sample_primary$cognitivegroups_w8)), 
             srhealth_low = c(percent(sample_primary$sphusmod_w8, 1), percent(cog1$sphusmod_w8, 1), percent(cog2$sphusmod_w8, 1), percent(cog3$sphusmod_w8, 1), percent(cog4$sphusmod_w8, 1), p_chisq(sample_primary$sphusmod_w8, sample_primary$cognitivegroups_w8)), 
             frailty = c(percent(sample_primary$sharefifrail_w8, 2), percent(cog1$sharefifrail_w8, 2), percent(cog2$sharefifrail_w8, 2), percent(cog3$sharefifrail_w8, 2), percent(cog4$sharefifrail_w8, 2), p_chisq(sample_primary$sharefifrail_w8, sample_primary$cognitivegroups_w8)), 
             hospitalised = c(percent(sample_primary$hc012mod_w8, 1), percent(cog1$hc012mod_w8, 1), percent(cog2$hc012mod_w8, 1), percent(cog3$hc012mod_w8, 1), percent(cog4$hc012mod_w8, 1),  p_chisq(sample_primary$hc012mod_w8, sample_primary$cognitivegroups_w8))
             )))

##Descriptive statistics for age & sex (presented in main text)
round(mean(sample_primary$age_w8), 2); round(sd(sample_primary$age_w8), 2)
percent(sample_primary$female, 1)
