#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following packages:
library(DescTools) #package version 0.99.49
library(pROC) #package version 1.18.0
library(dominanceanalysis) #package version 2.0.0

#3.2.2. Table 2

##Logistic regression models
D_MCI_v_SMC_NC <- glm(D_MCI_v_SMC_NC ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")
D_MCI_v_NC <- glm(D_MCI_v_NC ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")
MCI_v_D <- glm(MCI_v_D ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")
MCI_v_SMC_NC <- glm(MCI_v_SMC_NC ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")
MCI_v_NC <- glm(MCI_v_NC ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")
D_v_MCI_SMC_NC <- glm(D_v_MCI_SMC_NC ~ wreg10_w8 + fluency30 + recall10_w8, data = sample_primary, family = "binomial")

##Table 2
Table_2 <- rbind(
  data.frame(t(c( #Results for D_MCI_v_SMC_NC
    comparison = paste("D_MCI_v_SMC_NC"),
    round(D_MCI_v_SMC_NC[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(D_MCI_v_SMC_NC[["coefficients"]][[2]]) / min(abs(D_MCI_v_SMC_NC[["coefficients"]][[2]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[3]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(D_MCI_v_SMC_NC[["coefficients"]][[3]]) / min(abs(D_MCI_v_SMC_NC[["coefficients"]][[2]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[3]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(D_MCI_v_SMC_NC[["coefficients"]][[4]]) / min(abs(D_MCI_v_SMC_NC[["coefficients"]][[2]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[3]]), abs(D_MCI_v_SMC_NC[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$D_MCI_v_SMC_NC, predict(D_MCI_v_SMC_NC, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(D_MCI_v_SMC_NC, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(D_MCI_v_SMC_NC)[["contribution.average"]][["r2.e"]], 3)))), #Average R2 value of each subtest
  data.frame(t(c( #Results for D_MCI_v_NC
    comparison = paste("D_MCI_v_NC"),
    round(D_MCI_v_NC[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(D_MCI_v_NC[["coefficients"]][[2]]) / min(abs(D_MCI_v_NC[["coefficients"]][[2]]), abs(D_MCI_v_NC[["coefficients"]][[3]]), abs(D_MCI_v_NC[["coefficients"]][[4]])) ), 
      round( abs(D_MCI_v_NC[["coefficients"]][[3]]) / min(abs(D_MCI_v_NC[["coefficients"]][[2]]), abs(D_MCI_v_NC[["coefficients"]][[3]]), abs(D_MCI_v_NC[["coefficients"]][[4]])) ), 
      round( abs(D_MCI_v_NC[["coefficients"]][[4]]) / min(abs(D_MCI_v_NC[["coefficients"]][[2]]), abs(D_MCI_v_NC[["coefficients"]][[3]]), abs(D_MCI_v_NC[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$D_MCI_v_NC, predict(D_MCI_v_NC, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(D_MCI_v_NC, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(D_MCI_v_NC)[["contribution.average"]][["r2.e"]], 3)))), #Average R2 value of each subtest
  data.frame(t(c( #Results for MCI_v_D
    comparison = paste("MCI_v_D"),
    round(MCI_v_D[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(MCI_v_D[["coefficients"]][[2]]) / min(abs(MCI_v_D[["coefficients"]][[2]]), abs(MCI_v_D[["coefficients"]][[3]]), abs(MCI_v_D[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_D[["coefficients"]][[3]]) / min(abs(MCI_v_D[["coefficients"]][[2]]), abs(MCI_v_D[["coefficients"]][[3]]), abs(MCI_v_D[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_D[["coefficients"]][[4]]) / min(abs(MCI_v_D[["coefficients"]][[2]]), abs(MCI_v_D[["coefficients"]][[3]]), abs(MCI_v_D[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$MCI_v_D, predict(MCI_v_D, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(MCI_v_D, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(MCI_v_D)[["contribution.average"]][["r2.e"]], 3)))), #Average R2 value of each subtest
  data.frame(t(c( #Results for MCI_v_SMC_NC
    comparison = paste("MCI_v_SMC_NC"),
    round(MCI_v_SMC_NC[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(MCI_v_SMC_NC[["coefficients"]][[2]]) / min(abs(MCI_v_SMC_NC[["coefficients"]][[2]]), abs(MCI_v_SMC_NC[["coefficients"]][[3]]), abs(MCI_v_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_SMC_NC[["coefficients"]][[3]]) / min(abs(MCI_v_SMC_NC[["coefficients"]][[2]]), abs(MCI_v_SMC_NC[["coefficients"]][[3]]), abs(MCI_v_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_SMC_NC[["coefficients"]][[4]]) / min(abs(MCI_v_SMC_NC[["coefficients"]][[2]]), abs(MCI_v_SMC_NC[["coefficients"]][[3]]), abs(MCI_v_SMC_NC[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$MCI_v_SMC_NC, predict(MCI_v_SMC_NC, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(MCI_v_SMC_NC, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(MCI_v_SMC_NC)[["contribution.average"]][["r2.e"]], 3)))), #Average R2 value of each subtest
  data.frame(t(c( #Results for MCI_v_NC
    comparison = paste("MCI_v_NC"),
    round(MCI_v_NC[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(MCI_v_NC[["coefficients"]][[2]]) / min(abs(MCI_v_NC[["coefficients"]][[2]]), abs(MCI_v_NC[["coefficients"]][[3]]), abs(MCI_v_NC[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_NC[["coefficients"]][[3]]) / min(abs(MCI_v_NC[["coefficients"]][[2]]), abs(MCI_v_NC[["coefficients"]][[3]]), abs(MCI_v_NC[["coefficients"]][[4]])) ), 
      round( abs(MCI_v_NC[["coefficients"]][[4]]) / min(abs(MCI_v_NC[["coefficients"]][[2]]), abs(MCI_v_NC[["coefficients"]][[3]]), abs(MCI_v_NC[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$MCI_v_NC, predict(MCI_v_NC, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(MCI_v_NC, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(MCI_v_NC)[["contribution.average"]][["r2.e"]], 3)))), #Average R2 value of each subtest
  data.frame(t(c( #Results for D_v_MCI_SMC_NC
    comparison = paste("D_v_MCI_SMC_NC"),
    round(D_v_MCI_SMC_NC[["coefficients"]], 3),
    ratio = paste( #rounded scoring per word
      round( abs(D_v_MCI_SMC_NC[["coefficients"]][[2]]) / min(abs(D_v_MCI_SMC_NC[["coefficients"]][[2]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[3]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(D_v_MCI_SMC_NC[["coefficients"]][[3]]) / min(abs(D_v_MCI_SMC_NC[["coefficients"]][[2]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[3]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[4]])) ), 
      round( abs(D_v_MCI_SMC_NC[["coefficients"]][[4]]) / min(abs(D_v_MCI_SMC_NC[["coefficients"]][[2]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[3]]), abs(D_v_MCI_SMC_NC[["coefficients"]][[4]])) ),
      sep = ":"),
    AUC = round( roc(sample_primary$D_v_MCI_SMC_NC, predict(D_v_MCI_SMC_NC, sample_primary), direction="<", levels=c(0, 1))[["auc"]][1], 3), #AUC value of the full model
    R2 = round( PseudoR2(D_v_MCI_SMC_NC, "Efron"), 3), #R2 value of the full model
    round( dominanceAnalysis(D_v_MCI_SMC_NC)[["contribution.average"]][["r2.e"]], 3)))) #Average R2 value of each subtest
)
