#Completed in R version 4.2.1 (2022-06-23 ucrt) [platform: x86_64-w64-mingw32]
#Including the following package:
library(pROC) #package version 1.18.0

#3.2.3. Table S4

#Calculation of weighting ratios
wreg <- c(0.5, 1, 2, 3, 4)
fluency <- c(0.5, 1, 2, 3, 4)
wrecall <- c(0.5, 1, 2, 3, 4)
wgts <- expand.grid(wreg, fluency, wrecall) #all combinations of weights
wgts$ratio1 <- round(wgts$Var1 / pmin(wgts$Var1, wgts$Var2, wgts$Var3)*0.5, 2) #ratio taking 0.5 as the minimum value
wgts$ratio2 <- round(wgts$Var2 / pmin(wgts$Var1, wgts$Var2, wgts$Var3)*0.5, 2) #ratio taking 0.5 as the minimum value
wgts$ratio3 <- round(wgts$Var3 / pmin(wgts$Var1, wgts$Var2, wgts$Var3)*0.5, 2) #ratio taking 0.5 as the minimum value
wgts <- wgts[!duplicated(wgts[c("ratio1","ratio2", "ratio3")]),] #Keep only unique weighting ratios

##Verbal fluency (20 animals maximum)
df_v20 <- data.frame(sample_primary$mergeid) 
for(i in 1:nrow(wgts)) {
  output <- print(wgts[[i,4]]*sample_primary$wreg10_w8 + wgts[[i,5]]*(pmin(sample_primary$fluency_w8,20)) + wgts[[i,6]]*sample_primary$recall10_w8)
  output <- as.data.frame(output) #all weighted combinations including 20 animal verbal fluency
  df_v20 <- cbind(df_v20, output)}
df_v20[2:(nrow(wgts)+1)] <- round(df_v20[2:(nrow(wgts)+1)])

##Verbal fluency (30 animals maximum)
df_v30 <- data.frame(sample_primary$mergeid) 
for(i in 1:nrow(wgts)) {
  output <- print(wgts[[i,4]]*sample_primary$wreg10_w8 + wgts[[i,5]]*(pmin(sample_primary$fluency_w8,30)) + wgts[[i,6]]*sample_primary$recall10_w8)
  output <- as.data.frame(output) #all weighted combinations including 30 animal verbal fluency
  df_v30 <- cbind(df_v30, output)}
df_v30[2:(nrow(wgts)+1)] <- round(df_v30[2:(nrow(wgts)+1)])

##Verbal fluency (40 animals maximum)
df_v40 <- data.frame(sample_primary$mergeid) 
for(i in 1:nrow(wgts)) {
  output <- print(wgts[[i,4]]*sample_primary$wreg10_w8 + wgts[[i,5]]*(pmin(sample_primary$fluency_w8,40)) + wgts[[i,6]]*sample_primary$recall10_w8)
  output <- as.data.frame(output) #all weighted combinations including 40 animal verbal fluency
  df_v40 <- cbind(df_v40, output)}
df_v40[2:(nrow(wgts)+1)] <- round(df_v40[2:(nrow(wgts)+1)])

#Results for df_v20
##1 D_MCI_v_SMC_NC
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$D_MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v20 <- cbind(max_animals=20, wgts[,-1:-3], tp1=round(wgts$ratio1*10), tp2=round(wgts$ratio2*20), tp3=round(wgts$ratio3*10), TP=round(wgts$ratio1*10 + wgts$ratio2*20 + wgts$ratio3*10), D_MCI_v_SMC_NC=results)
##2 D_MCI_v_NC
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$D_MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v20 <- cbind(results_v20, D_MCI_v_NC=results)
##3 MCI_v_D
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$MCI_v_D, val[[1]], direction=">", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v20 <- cbind(results_v20, MCI_v_D=results)
##4 MCI_v_SMC_NC
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v20 <- cbind(results_v20, MCI_v_SMC_NC=results)
##5 MCI_v_NC
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v20 <- cbind(results_v20, MCI_v_NC=results)
##6 D_v_MCI_SMC_NC
auc_vals <- function(x) {
  val <- df_v20[x]
  roc(sample_primary$D_v_MCI_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v20 <- cbind(results_v20, D_v_MCI_SMC_NC=results)

#Results for df_v30
##1 D_MCI_v_SMC_NC
library("pROC")
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$D_MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v30 <- cbind(max_animals=30, wgts[,-1:-3], tp1=round(wgts$ratio1*10), tp2=round(wgts$ratio2*30), tp3=round(wgts$ratio3*10), TP=round(wgts$ratio1*10 + wgts$ratio2*30 + wgts$ratio3*10), D_MCI_v_SMC_NC=results)
##2 D_MCI_v_NC
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$D_MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v30 <- cbind(results_v30, D_MCI_v_NC=results)
##3 MCI_v_D
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$MCI_v_D, val[[1]], direction=">", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v30 <- cbind(results_v30, MCI_v_D=results)
##4 MCI_v_SMC_NC
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v30 <- cbind(results_v30, MCI_v_SMC_NC=results)
##5 MCI_v_NC
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v30 <- cbind(results_v30, MCI_v_NC=results)
##6 D_v_MCI_SMC_NC
auc_vals <- function(x) {
  val <- df_v30[x]
  roc(sample_primary$D_v_MCI_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v30 <- cbind(results_v30, D_v_MCI_SMC_NC=results)

#Results for df_v40
##1 D_MCI_v_SMC_NC
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$D_MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v40 <- cbind(max_animals=40, wgts[,-1:-3], tp1=round(wgts$ratio1*10), tp2=round(wgts$ratio2*40), tp3=round(wgts$ratio3*10), TP=round(wgts$ratio1*10 + wgts$ratio2*40 + wgts$ratio3*10), D_MCI_v_SMC_NC=results)
##2 D_MCI_v_NC
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$D_MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1), auc_vals)
results_v40 <- cbind(results_v40, D_MCI_v_NC=results)
##3 MCI_v_D
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$MCI_v_D, val[[1]], direction=">", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v40 <- cbind(results_v40, MCI_v_D=results)
##4 MCI_v_SMC_NC
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$MCI_v_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v40 <- cbind(results_v40, MCI_v_SMC_NC=results)
##5 MCI_v_NC
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$MCI_v_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v40 <- cbind(results_v40, MCI_v_NC=results)
##6 D_v_MCI_SMC_NC
auc_vals <- function(x) {
  val <- df_v40[x]
  roc(sample_primary$D_v_MCI_SMC_NC, val[[1]], direction="<", levels=c(1, 0))[["auc"]][1]}
results <- sapply(2:(nrow(wgts)+1),auc_vals)
results_v40 <- cbind(results_v40, D_v_MCI_SMC_NC=results)

#Combining results for Table S4
Table_S4 <- rbind(results_v20, results_v30, results_v40)
Table_S4$average <- rowMeans(Table_S4[,9:14],) #Average AUC
Table_S4 <- Table_S4[order(Table_S4$average,decreasing=TRUE),] #Orders values by average AUC
Table_S4[,9:15] <- round(Table_S4[,9:15],3) #Rounds AUC values for 3 decimal places
write.csv(Table_S4, "output/Table_S4.csv")
